/**********************************************************************/
// File Name: {FM_project_loc}/M1_PMSM_appconfig.h 
//
// Date:  12. June, 2017
//
// Automatically generated file by MCAT
// - static configuration of the PMSM FOC application
/**********************************************************************/

#ifndef __M1_PMSM_APPCONFIG_H
#define __M1_PMSM_APPCONFIG_H


//Motor Parameters                      
//----------------------------------------------------------------------
//Pole-pair number                      = 3 [-]
//Stator resistance                     = 0.376 [Ohms]
//Direct axis inductance                = 0.00022 [H]
//Quadrature axis inductance            = 0.00027 [H]
//Back-EMF constant                     = 0.0070665 [V.sec/rad]
//Drive inertia                         = 0.000001 [kg.m2]
//Nominal current                       = 5 [A]
//Nominal speed                         = 3000 [rpm]

#define M1_MOTOR_PP                        (3.0F)
#define M1_MOTOR_PP_GAIN                   FRAC32(0.75)
#define M1_MOTOR_PP_SHIFT                  (2)

//Application scales                    
//----------------------------------------------------------------------
#define M1_I_MAX                           (10.0F)
#define M1_U_DCB_MAX                       (36.0F)
#define M1_N_MAX                           (3300.0F)
#define M1_WEL_MAX                         (1036.73F)

//Application Fault Triggers            
//----------------------------------------------------------------------
#define M1_U_DCB_TRIP                      (28.8F)
#define M1_U_DCB_UNDER                     (11.0F)
#define M1_U_DCB_OVER                      (28.8F)
#define M1_I_PH_OVER                       (6.1F)
#define M1_TEMP_OVER                       (100.0F)

//DC Bus voltage IIR1 filter constants  
//----------------------------------------------------------------------
//Cut-off frequency                     = 100 [Hz]
//Sample time                           = 0.0001 [sec]
//----------------------------------------------------------------------
#define M1_UDCB_IIR_B0                     (0.030459027951421222F)
#define M1_UDCB_IIR_B1                     (0.030459027951421222F)
#define M1_UDCB_IIR_A1                     (-0.9390819440971575F)
//Mechanical Alignment                  
#define M1_ALIGN_VOLTAGE                   (1.7F)
#define M1_ALIGN_DURATION                  (15000)

//Current Loop Control                  
//----------------------------------------------------------------------
//Loop Bandwidth                        = 240 [Hz]
//Loop Attenuation                      = 0.707 [-]
//Loop sample time                      = 0.0001 [sec]
//----------------------------------------------------------------------
//Current Controller Output Limit       
#define M1_CLOOP_LIMIT                     (0.9F)
//D-axis Controller - Recurrent type    
#define M1_D_CC1SC                         (0.11811111387990301F)
#define M1_D_CC2SC                         (-0.06808406309166127F)
#define M1_D_B0                            (0.3495348602588324F)
#define M1_D_B1                            (0.0F)
#define M1_D_A1                            (-0.6504651397411676F)
//Q-axis Controller - Recurrent type    
#define M1_Q_CC1SC                         (0.2304090943071537F)
#define M1_Q_CC2SC                         (-0.16901225924885702F)
#define M1_Q_B0                            (0.23514005639481034F)
#define M1_Q_B1                            (0.0F)
#define M1_Q_A1                            (-0.7648599436051896F)

//Speed Loop Control                    
//----------------------------------------------------------------------
//Loop Bandwidth                        = 20 [Hz]
//Loop Attenuation                      = 1 [-]
//Loop sample time                      = 0.001 [sec]
//----------------------------------------------------------------------
//Speed Controller - Parallel type      
#define M1_SPEED_PI_PROP_GAIN              (0.03442841264207992F)
#define M1_SPEED_PI_INTEG_GAIN             (0.0010816004823111624F)
#define M1_SPEED_LOOP_HIGH_LIMIT           (7.65F)
#define M1_SPEED_LOOP_LOW_LIMIT            (-7.65F)

#define M1_SPEED_RAMP_UP                   (0.47124F)
#define M1_SPEED_RAMP_DOWN                 (0.47124F)

#define M1_SPEED_LOOP_CNTR                 (10)

#define M1_POSPE_SPEED_FILTER_MA_LAMBDA    (0.5F)

//Position & Speed Sensors Module       
//Loop sample time                      = 0.0001 [sec]
//----------------------------------------------------------------------
//Encoder Loop Bandwidth                = 100 [Hz]
//Encoder Loop Attenuation              = 1 [-]
#define M1_POSPE_ENC_TO_CC1                (1276.376270238096F)
#define M1_POSPE_ENC_TO_CC2                (-1236.8978526337387F)
#define M1_POSPE_ENC_TO_INTEG_GAIN         (0.00005F)
#define M1_ENC_PULSES                      (1024)
//----------------------------------------------------------------------
//Resolver Loop Bandwidth               = 100 [Hz]
//Resolver Loop Attenuation             = 1 [-]
#define M1_POSPE_RES_TO_CC1                (1276.376270238096F)
#define M1_POSPE_RES_TO_CC2                (-1236.8978526337387F)
#define M1_POSPE_RES_TO_INTEG_GAIN         (0.00005F)
#define M1_RES_PP_GAIN                     (1.0F)

//Control Structure Module - Scalar Control
//----------------------------------------------------------------------
#define M1_SCALAR_VHZ_FACTOR_GAIN          (0.025916790933084237F)
#define M1_SCALAR_INTEG_GAIN               FRAC32(0.0165)
#define M1_SCALAR_INTEG_SHIFT              (0)
#define M1_SCALAR_RAMP_UP                  (0.04712F)
#define M1_SCALAR_RAMP_DOWN                (0.04712F)

//FreeMASTER Scale Variables            
//----------------------------------------------------------------------
//Note: Scaled at input = 1000          
//----------------------------------------------------------------------
#define M1_FM_SPEED_RAD_MEC_SCALE          (1000)
#define M1_FM_SPEED_RPM_EL_SCALE           (9549)
#define M1_FM_SPEED_RPM_MEC_SCALE          (3183)
#define M1_FM_POSITION_DEG_SCALE           (57296)

#endif

//End of generated file                 
/**********************************************************************/
