/**********************************************************************/
// File Name: {FM_project_loc}/M2_PMSM_AppConfig.h 
//
// Date:  12. June, 2017
//
// Automatically generated file by MCAT
// - static configuration of the PMSM FOC application
/**********************************************************************/

#ifndef __M2_PMSM_APPCONFIG_H
#define __M2_PMSM_APPCONFIG_H


//Motor Parameters                      
//----------------------------------------------------------------------
//Pole-pair number                      = 3 [-]
//Stator resistance                     = 0.376 [Ohms]
//Direct axis inductance                = 0.00022 [H]
//Quadrature axis inductance            = 0.00027 [H]
//Back-EMF constant                     = 0.0070665 [V.sec/rad]
//Drive inertia                         = 0.000001 [kg.m2]
//Nominal current                       = 7.65 [A]
//Nominal speed                         = 3000 [rpm]

#define M2_MOTOR_PP                        (3.0F)
#define M2_MOTOR_PP_GAIN                   FRAC32(0.75)
#define M2_MOTOR_PP_SHIFT                  (2)

//Application scales                    
//----------------------------------------------------------------------
#define M2_I_MAX                           (10.0F)
#define M2_U_DCB_MAX                       (36.0F)
#define M2_N_MAX                           (3300.0F)
#define M2_WEL_MAX                         (1036.73F)

//Application Fault Triggers            
//----------------------------------------------------------------------
#define M2_U_DCB_TRIP                      (28.0F)
#define M2_U_DCB_UNDER                     (10.0F)
#define M2_U_DCB_OVER                      (30.0F)
#define M2_I_PH_OVER                       (9.8F)
#define M2_TEMP_OVER                       (100.0F)

//DC Bus voltage IIR1 filter constants  
//----------------------------------------------------------------------
//Cut-off frequency                     = 100 [Hz]
//Sample time                           = 0.0001 [sec]
//----------------------------------------------------------------------
#define M2_UDCB_IIR_B0                     (0.030459027951421222F)
#define M2_UDCB_IIR_B1                     (0.030459027951421222F)
#define M2_UDCB_IIR_A1                     (-0.9390819440971575F)
//Mechanical Alignment                  
#define M2_ALIGN_VOLTAGE                   (2.0F)
#define M2_ALIGN_DURATION                  (15000)

//Current Loop Control                  
//----------------------------------------------------------------------
//Loop Bandwidth                        = 230 [Hz]
//Loop Attenuation                      = 0.707 [-]
//Loop sample time                      = 0.0001 [sec]
//----------------------------------------------------------------------
//Current Controller Output Limit       
#define M2_CLOOP_LIMIT                     (0.9F)
//D-axis Controller - Recurrent type    
#define M2_D_CC1SC                         (0.09652434683618355F)
#define M2_D_CC2SC                         (-0.050579364428232354F)
#define M2_D_B0                            (0.3844870137275977F)
#define M2_D_B1                            (0.0F)
#define M2_D_A1                            (-0.6155129862724022F)
//Q-axis Controller - Recurrent type    
#define M2_Q_CC1SC                         (0.20391624384440704F)
#define M2_Q_CC2SC                         (-0.14752921998010332F)
#define M2_Q_B0                            (0.2429325888334692F)
#define M2_Q_B1                            (0.0F)
#define M2_Q_A1                            (-0.7570674111665309F)

//Speed Loop Control                    
//----------------------------------------------------------------------
//Loop Bandwidth                        = 20 [Hz]
//Loop Attenuation                      = 1 [-]
//Loop sample time                      = 0.001 [sec]
//----------------------------------------------------------------------
//Speed Controller - Parallel type      
#define M2_SPEED_PI_PROP_GAIN              (0.03442841264207992F)
#define M2_SPEED_PI_INTEG_GAIN             (0.0010816004823111624F)
#define M2_SPEED_LOOP_HIGH_LIMIT           (7.0F)
#define M2_SPEED_LOOP_LOW_LIMIT            (-7.0F)

#define M2_SPEED_RAMP_UP                   (0.47124F)
#define M2_SPEED_RAMP_DOWN                 (0.47124F)

#define M2_SPEED_LOOP_CNTR                 (10)

#define M2_POSPE_SPEED_FILTER_MA_LAMBDA    (0.5F)

//Position & Speed Sensors Module       
//Loop sample time                      = 0.0001 [sec]
//----------------------------------------------------------------------
//Encoder Loop Bandwidth                = 105 [Hz]
//Encoder Loop Attenuation              = 1 [-]
#define M2_POSPE_ENC_TO_CC1                (1341.2313922121152F)
#define M2_POSPE_ENC_TO_CC2                (-1297.7064368033111F)
#define M2_POSPE_ENC_TO_INTEG_GAIN         (0.00005F)
#define M2_ENC_PULSES                      (1024)
//----------------------------------------------------------------------
//Resolver Loop Bandwidth               = 105 [Hz]
//Resolver Loop Attenuation             = 1 [-]
#define M2_POSPE_RES_TO_CC1                (1341.2313922121152F)
#define M2_POSPE_RES_TO_CC2                (-1297.7064368033111F)
#define M2_POSPE_RES_TO_INTEG_GAIN         (0.00005F)
#define M2_RES_PP_GAIN                     (1.0F)

//Control Structure Module - Scalar Control
//----------------------------------------------------------------------
#define M2_SCALAR_VHZ_FACTOR_GAIN          (0.01383693075240938F)
#define M2_SCALAR_INTEG_GAIN               FRAC32(0.0165)
#define M2_SCALAR_INTEG_SHIFT              (0)
#define M2_SCALAR_RAMP_UP                  (0.04712F)
#define M2_SCALAR_RAMP_DOWN                (0.04712F)

//FreeMASTER Scale Variables            
//----------------------------------------------------------------------
//Note: Scaled at input = 1000          
//----------------------------------------------------------------------
#define M2_FM_SPEED_RAD_MEC_SCALE          (1000)
#define M2_FM_SPEED_RPM_EL_SCALE           (9549)
#define M2_FM_SPEED_RPM_MEC_SCALE          (3183)
#define M2_FM_POSITION_DEG_SCALE           (57296)

#endif

//End of generated file                 
/**********************************************************************/
