/******************************************************************************
*
* Copyright 2006-2015 Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
*
***************************************************************************//*!
*
* @file     ADC_MEAS_FLT.h
*
* @author   r63172
*
* @version  1.0.1.0
*
* @date     Jul-13-2012
*
* @brief    Header file for MPC5643L rev. 2.0 Board Support Package - ADC module
*
*******************************************************************************
*
* This file includes MACRO and user type definitions of Board Support Package
* for MPC5643L rev. 2.0.
*
******************************************************************************/
#ifndef _ADC_MEAS_FLT_H_
#define _ADC_MEAS_FLT_H_

#include "state_machine.h"
#include "MPC5643L_qs.h"
#include "MPC5643L_LLD_qs.h"

/******************************************************************************
| Defines and macros            (scope: module-local)
-----------------------------------------------------------------------------*/
#define ADC_RAW_RESULT_DEFAULT  {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}
#define ADC_OFFSET_DEFAULT      {0,0,0,0,0,0}
#define ADC_PARAM_DEFAULT       {0}
#define ADC_FLAGS_DEFAULT       {0}

#define ADC_MODULE_DEFAULT  	{ADC_RAW_RESULT_DEFAULT,\
								ADC_OFFSET_DEFAULT,\
								ADC_PARAM_DEFAULT,\
								ADC_FLAGS_DEFAULT,\
								0}

#define FILTER_MA2_DEFAULT 		{0,0}

/* ADC setting related to the UNI3_ M1 connector*/
#define UNI3_M1_CFG_DEFAULT    ADC1_BASE,ADC_CDR11_OFFSET,\
							   ADC1_BASE,ADC_CDR12_OFFSET,\
							   ADC0_BASE,ADC_CDR2_OFFSET,\
							   ADC0_BASE,ADC_CDR1_OFFSET,\
							   M1_ALIGN_DURATION,\
							   M1_ALIGN_VOLTAGE,\
							   FLEXPWM0_BASE

/* ADC setting related to the UNI3_ M2 connector*/
#define UNI3_M2_CFG_DEFAULT    ADC0_BASE,ADC_CDR13_OFFSET,\
							   ADC1_BASE,ADC_CDR14_OFFSET,\
							   ADC1_BASE,ADC_CDR2_OFFSET,\
							   ADC0_BASE,ADC_CDR3_OFFSET,\
							   M2_ALIGN_DURATION,\
							   M2_ALIGN_VOLTAGE,\
							   FLEXPWM1_BASE

/******************************************************************************
| Typedefs and structures       (scope: module-local)
-----------------------------------------------------------------------------*/

/******************************************************************************
| Exported Variables
-----------------------------------------------------------------------------*/

/******************************************************************************
| Exported function prototypes
-----------------------------------------------------------------------------*/
extern tBool ADC_ModuleClear(pmsmDrive_t *ptr);
extern tBool ADC_ModuleCalib(pmsmDrive_t *ptr);
extern tBool ADC_Measure2Ph(pmsmDrive_t *ptr);
extern tBool ADC_Measure3Ph(pmsmDrive_t *ptr, tFloat Imax);
extern tBool ADC_UdcVoltageMeasure(pmsmDrive_t *ptr, tFloat Umax);

/******************************************************************************
| Inline functions
-----------------------------------------------------------------------------*/

#endif /* _ADC_MEAS_FLT_H_ */
