/******************************************************************************
*
* Copyright 2006-2015 Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
*
***************************************************************************//*!
*
* @file     adc.h
*
* @author   r63172
* 
* @version  1.0.1.0
* 
* @date     Jul-13-2012
* 
* @brief    ADC - Analog to Digital Converter for MPC5643L
*
*******************************************************************************
*
* This file includes initial setting and MACRO definitions of MPC5643L ADC
* peripheral module.
*
******************************************************************************/
#ifndef _ADC_H_
#define _ADC_H_

/******************************************************************************
* Global ADC variables definition
******************************************************************************/
// Pointer to ADC structure
extern volatile ADC_tag *pADC_0;
extern volatile ADC_tag *pADC_1;

/******************************************************************************
* ADC MACRO definitions
******************************************************************************/

/******************************************************************************
* ADC registers bit definition
******************************************************************************/

/******************************************************************************
* Exported functions
*******************************************************************************/
extern void adc0_init(void);
extern void adc1_init(void);
extern void adc_off_canc(volatile ADC_tag *pADC);

#endif /* _ADC_H_ */
