/******************************************************************************
*
* Copyright 2006-2015 Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
*
***************************************************************************//*!
*
* @file     ctu.h
*
* @author   r63172
* 
* @version  1.0.1.0
* 
* @date     Jul-13-2012
* 
* @brief    CTU - Cross Triggering Unit for MPC5643L
*
*******************************************************************************
*
* This file includes initial setting and MACRO definitions of MPC5643L CTU
* peripheral module.
*
******************************************************************************/
#ifndef _CTU_H_
#define _CTU_H_

/******************************************************************************
* Global CTU variables definition
******************************************************************************/
// Pointer to CTU structure
extern volatile CTU_tag *pCTU;

/* -------------------------
 * FOR DEBUG ONLY
 * -------------------------*/
#if 0
//typedef union {
//       vuint16_t R;
//       struct {
//           vuint16_t CIR:1;
//           vuint16_t LC:1;
//           vuint16_t CMS:1;
//           vuint16_t FIFO:3;
//           vuint16_t :1;
//           vuint16_t CHB:4;
//           vuint16_t :1;
//           vuint16_t CHA:4;
//       } B;
//   } tCLRdual;
//   
//typedef union {
//       vuint16_t R;
//       struct {
//           vuint16_t CIR:1;
//           vuint16_t LC:1;
//           vuint16_t CMS:1;
//           vuint16_t FIFO:3;
//           vuint16_t:1;
//           vuint16_t:3;
//           vuint16_t SU:1;
//           vuint16_t:1;
//           vuint16_t CH:4;
//       } B;
//   } tCLRsingle;
//
//#ifdef SINGLE
//   tCLRsingle *pCLR0=&(pCTU->CLR[0]);
//#else
//   tCLRdual   *pCLR0=&(pCTU->CLR[0]);
//#endif

#endif
   
/******************************************************************************
* CTU MACRO definitions
******************************************************************************/

/******************************************************************************
* CTU registers bit definition
******************************************************************************/

/******************************************************************************
* Exported functions
*******************************************************************************/
extern void ctu_init(void);

/******************************************************************************
* Inline functions
*******************************************************************************/
static inline void ctu_disable(void)
{
    pCTU->CTUCR.B.CTU_ODIS       = 0x1;      // Disable CTU output
    pCTU->CTUCR.B.CTU_ADC_RESET  = 0x1;      // Reset CTU/ADC state machine
}

static inline void ctu_enable(void)
{
    pCTU->CTUCR.B.CTU_ODIS   = 0x0;          // Enable CTU output
}

#endif /* _CTU_H_ */
