/*
 *######################################################################
 *                                RAppIDJDP
 *           Rapid Application Initialization and Documentation Tool
 *                         Freescale Semiconductor Inc.
 *                (c) Copyright 2004-2008 Freescale Semiconductor, Inc.
 *                         ALL RIGHTS RESERVED.
 *                        MPC5604P Configuration Tool 
 *######################################################################
 *
 * Project Name           : ALARA_benchmark_FLASH
 *
 * Project File           : ALARA_benchmark_FLASH.rsp
 *
 * Revision Number        : 1.0
 *
 * Tool Version           : 1.1.0.3
 *
 * file                   : flash_init.c
 *
 * Target Compiler        : GreenHills
 *
 * Target Part            : MPC5604P
 *
 * Part Errata Fixes      : none
 *
 * Project Last Save Date : 13-Jul-2009 15:56:18
 *
 * Created on Date        : 13-Jul-2009 15:56:25
 *
 * Brief Description      : This file contains FlashBIU configuration 
 *
 ******************************************************************************** 
 *
 * Detail Description     : This File contains function which configures code flash(Bank0)
 *                          Register setup, Data Flash(Bank1) Register setup and access
 *                          control for masters
 *
 ******************************************************************************** 
 *
 *######################################################################
*/

 
 
/********************  Dependent Include files here **********************/

#include "flash_init.h"
#include "MPC5643L_qs.h"

/*********************  Initialization Function(s) ************************/

void flash_init_fnc (void)
{

/* ----------------------------------------------------------- */
/*	                  FLASH_BIU setup                          */
/* ----------------------------------------------------------- */
      while( 0 == CFLASH.MCR.B.DONE  )    
     {     
     ;     
     }     
        /* Registers cannot be written until MCR.DONE is high.    */



/* ----------------------------------------------------------- */
/*                    FLASH_PFAPR Register setup(0xFFFFFFFF)                      */
/* ----------------------------------------------------------- */

      CFLASH.FAPR.R = 0xFFFFFFFF;    

        /* Master 3 ( FlexRay) Prefetch Enable : No prefetching    */
        /* Master 2 ( eDMA) Prefetch Enable : No prefetching    */
        /* Master 1 ( Nexus) Prefetch Enable : No prefetching    */
        /* Master 0 ( Core) Prefetch Enable : No prefetching    */

        /* Master 3 ( FlexRay) Access Control : Read and Write    */
        /* Master 2 ( eDMA) Access Control : Read and Write    */
        /* Master 1 ( Nexus) Access Control : Read and Write    */
        /* Master 0 ( Core) Access Control : Read and Write    */


/* ----------------------------------------------------------- */
/*                    FLASH_PFCR0 Flash Bank0 Register setup(0x104380ED)                      */
/* ----------------------------------------------------------- */

      CFLASH.PFCR0.R = 0x104380ED;    
        /* Address Pipelining Control : 2 additional hold cycles    */

        /* Write Wait State Control :- 1 additional wait states    */

        /* Read Wait State Control :- 1 additional wait states    */

        /* Data Prefetch Enable :- No Prefetching    */

        /* Instruction Prefetch Enable :- Prefetching    */

        /* Prefetch Limit :- Prefetch on miss or hit    */

        /* BANK0 Port0 buffer enable :- Enabled    */

        /* Page Configuration - 3 instruction + 1 data    */



/* ----------------------------------------------------------- */
/*                    FLASH_PFCR1 Flash Bank1 Register setup(0x10438081)                      */
/* ----------------------------------------------------------- */

      CFLASH.PFCR1.R = 0x10438081;    
        /* Address Pipelining Control : 2 additional hold cycles    */

        /* Write Wait State Control :- 1 additional wait states    */

        /* Read Wait State control :- 1 additional wait states    */

        /* Bank1, port0 buffer enable :- Enabled    */



}

 
/*
 *######################################################################
 *                           End of File
 *######################################################################
*/

