/******************************************************************************
*
* Copyright 2006-2015 Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
*
***************************************************************************//*!
*
* @file     flexpwm.c
*
* @author   r63172
*
* @version  1.0.1.0
*
* @date     Jul-13-2012
*
* @brief    flexPWM - flexPWM module on MPC5643L
*
*******************************************************************************
*
* This file includes initial setting functions of MPC5643L flexPWM module.
*
******************************************************************************/
#include "MPC5643L_qs.h"
//#include "SWLIBS_Inlines.h"
#include "SWLIBS_Defines.h"
#include "flexpwm.h"

volatile mcPWM_tag *pPWM0;
volatile mcPWM_tag *pPWM1;
/******************************************************************************
* flexPWM functions
*****************************************************************************/
inline tS16
flexpwm_negate_val(register tS16 x)
{
    register tS32 y;

    y = -(tS32)(x);
    y = (y == -(tS32) INT16_MIN) ? (tS32) INT16_MAX:y;

    return (tS16)(y);
}

/***************************************************************************//*!
@brief

@param[in,out]  void
@param[in]      void

@return         void

@details

@note

@warning
******************************************************************************/
//void flexpwm_calcduty_50(volatile mcPWM_tag *ptrPWM,FLEXPWM_VAL_COMPL *pPwmVal)
//{
//    pPwmVal->s16A = F16Mul((tFrac16)(ptrPWM->SUB[0].VAL_1.R),FRAC16(0.5));
//    pPwmVal->s16B = F16Mul((tFrac16)(ptrPWM->SUB[0].VAL_1.R),FRAC16(0.5));
//    pPwmVal->s16C = F16Mul((tFrac16)(ptrPWM->SUB[0].VAL_1.R),FRAC16(0.5));
//}

/***************************************************************************//*!
@brief

@param[in,out]  void
@param[in]      void

@return         void

@details

@note

@warning
******************************************************************************/
//void flexpwm_calcduty(volatile mcPWM_tag *ptrPWM,FLEXPWM_VAL_COMPL *pPwmVal, SWLIBS_3Syst *pPwmAbc)
//{
//    pPwmVal->s16A = F16Mul((tFrac16)(ptrPWM->SUB[0].VAL_1.R),(tFrac16)(pPwmAbc->s32Arg1>>16));
//    pPwmVal->s16B = F16Mul((tFrac16)(ptrPWM->SUB[0].VAL_1.R),(tFrac16)(pPwmAbc->s32Arg2>>16));
//    pPwmVal->s16C = F16Mul((tFrac16)(ptrPWM->SUB[0].VAL_1.R),(tFrac16)(pPwmAbc->s32Arg3>>16));
//}

/***************************************************************************//*!
@brief

@param[in,out]  void
@param[in]      void

@return         void

@details

@note

@warning
******************************************************************************/
//void flexpwm_update_val_x(uint8_t sub, uint16_t t_off)
//{
//    FLEXPWM_0.SUB[sub].VAL[2].R = flexpwm_negate_val(t_off);
//    FLEXPWM_0.SUB[sub].VAL[3].R = t_off;
//    FLEXPWM_0.SUB[sub].VAL[4].R = flexpwm_negate_val(t_off);
//    FLEXPWM_0.SUB[sub].VAL[5].R = t_off;
//}

/***************************************************************************//*!
@brief

@param[in,out]  void
@param[in]      void

@return         void

@details

@note

@warning
******************************************************************************/
//void flexpwm_update_val_compl(volatile mcPWM_tag *ptrPWM, FLEXPWM_VAL_COMPL *pPwmVal)
//{
//    register uint8_t     ldok_test;
//
//    pPwmVal->s16A   &= 0xFFFE;
//    pPwmVal->s16B   &= 0xFFFE;
//    pPwmVal->s16C   &= 0xFFFE;
//
//    ptrPWM->SUB[0].VAL[2].R = flexpwm_negate_val(pPwmVal->s16A);
//    ptrPWM->SUB[0].VAL[3].R = (pPwmVal->s16A);
//    ptrPWM->SUB[0].VAL[4].R = flexpwm_negate_val(pPwmVal->s16A);
//    ptrPWM->SUB[0].VAL[5].R = (pPwmVal->s16A);
//
//    ptrPWM->SUB[1].VAL[2].R = flexpwm_negate_val(pPwmVal->s16B);
//    ptrPWM->SUB[1].VAL[3].R = (pPwmVal->s16B);
//    ptrPWM->SUB[1].VAL[4].R = flexpwm_negate_val(pPwmVal->s16B);
//    ptrPWM->SUB[1].VAL[5].R = (pPwmVal->s16B);
//
//    ptrPWM->SUB[2].VAL[2].R = flexpwm_negate_val(pPwmVal->s16C);
//    ptrPWM->SUB[2].VAL[3].R = (pPwmVal->s16C);
//    ptrPWM->SUB[2].VAL[4].R = flexpwm_negate_val(pPwmVal->s16C);
//    ptrPWM->SUB[2].VAL[5].R = (pPwmVal->s16C);
//
//    ldok_test = ptrPWM->MCTRL.B.LDOK;    // Read the LDOK bit field first
//
//    ptrPWM->MCTRL.B.LDOK = LDOK_SUB0|LDOK_SUB1|LDOK_SUB2|LDOK_SUB3;
//}

/***************************************************************************//*!
@brief          flexPWM0 init function

@param[in,out]  void
@param[in]      void

@return         void

@details        This function initializes basic start-up setting of the PWM0
                module.

@note

@warning
******************************************************************************/
void flexpwm0_init(void)
{
    static volatile tU8  i,j;
    volatile tU8     ldok_test;

    pPWM0=(mcPWM_tag *)&mcPWM_A;

    /*-------------------------------------------------------------------------
     * FlexPWM0 Reset
    --------------------------------------------------------------------------*/
    pPWM0->MCTRL.R          = 0x0;
    pPWM0->OUTEN.R          = 0x0;
    pPWM0->MASK.R           = 0x0;
    pPWM0->SWCOUT.R         = 0x0;
    pPWM0->DTSRCSEL.R       = 0x0;
    pPWM0->FCTRL.R          = 0x0;
    pPWM0->FFILT.R          = 0x0;
    pPWM0->FSTS.R           = 0xF;  // Clear Fault PIN flags manually

    for (j=0;j<=3;j++)
    {
        pPWM0->SUB[j].INIT.R        = 0x0;
        pPWM0->SUB[j].CTRL2.R       = 0x0;
        pPWM0->SUB[j].CTRL1.R        = 0x0;

        for(i=0;i<=5;i++)
        pPWM0->SUB[j].VAL[i].R      = 0x0;

        pPWM0->SUB[j].OCTRL.R       = 0x0;
        pPWM0->SUB[j].INTEN.R       = 0x0;
        pPWM0->SUB[j].DMAEN.R       = 0x0;
        pPWM0->SUB[j].TCTRL.R       = 0x0;
        pPWM0->SUB[j].DISMAP.R      = 0x07FF;
        pPWM0->SUB[j].DTCNT0.R      = 0x07FF;
        pPWM0->SUB[j].DTCNT1.R      = 0x0;
//        pPWM0->SUB[j].CAPTCOMPA.R   = 0x0;
//        pPWM0->SUB[j].CAPTCOMPB.R   = 0x0;
        pPWM0->SUB[j].CAPTCOMPX.R   = 0x0;
//        pPWM0->SUB[j].CAPTCTRLA.R   = 0x0;
//        pPWM0->SUB[j].CAPTCTRLB.R   = 0x0;
        pPWM0->SUB[j].CAPTCTRLX.R   = 0x0;
        pPWM0->SUB[j].DISMAP.R      = 0xFFFF;
    }

    /*-------------------------------------------------------------------------
     * FlexPWM0 Control registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM0_OUTEN                  /* OUTEN register */
        pPWM0->OUTEN.R          = FlexPWM0_OUTEN;
    #endif

    #ifdef FlexPWM0_MASK                   /* MASK register */
        pPWM0->MASK.R           = FlexPWM0_MASK;
    #endif

    #ifdef FlexPWM0_SWCOUT                 /* SWCOUT register */
        pPWM0->SWCOUT.R         = FlexPWM0_SWCOUT;
    #endif

    #ifdef FlexPWM0_DTSRCSEL               /* DTSRCSEL register */
        pPWM0->DTSRCSEL.R       = FlexPWM0_DTSRCSEL;
    #endif

    #ifdef FlexPWM0_FCTRL                  /* FCTRL register */
        pPWM0->FCTRL.R          = FlexPWM0_FCTRL;
    #endif

    #ifdef FlexPWM0_FFILT                  /* FFILT register */
        pPWM0->FFILT.R          = FlexPWM0_FFILT;
    #endif

    /*-------------------------------------------------------------------------
     * FlexPWM0 sub0 registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM0_INIT_sub0              /* INIT register */
        pPWM0->SUB[0].INIT.R    = FlexPWM0_INIT_sub0;
    #endif

    #ifdef FlexPWM0_CTRL2_sub0              /* CTRL2 register */
        pPWM0->SUB[0].CTRL2.R   = FlexPWM0_CTRL2_sub0;
    #endif

    #ifdef FlexPWM0_CTRL1_sub0              /* CTRL register */
        pPWM0->SUB[0].CTRL1.R    = FlexPWM0_CTRL1_sub0;
    #endif

    #ifdef FlexPWM0_VAL0_sub0              /* VAL0 register */
        pPWM0->SUB[0].VAL[0].R  = FlexPWM0_VAL0_sub0;
    #endif

    #ifdef FlexPWM0_VAL1_sub0              /* VAL1 register */
        pPWM0->SUB[0].VAL[1].R  = FlexPWM0_VAL1_sub0;
    #endif

    #ifdef FlexPWM0_VAL2_sub0              /* VAL2 register */
        pPWM0->SUB[0].VAL[2].R  = FlexPWM0_VAL2_sub0;
    #endif

    #ifdef FlexPWM0_VAL3_sub0              /* VAL3 register */
        pPWM0->SUB[0].VAL[3].R  = FlexPWM0_VAL3_sub0;
    #endif

    #ifdef FlexPWM0_VAL4_sub0              /* VAL4 register */
        pPWM0->SUB[0].VAL[4].R  = FlexPWM0_VAL4_sub0;
    #endif

    #ifdef FlexPWM0_VAL5_sub0              /* VAL5 register */
        pPWM0->SUB[0].VAL[5].R  = FlexPWM0_VAL5_sub0;
    #endif

    #ifdef FlexPWM0_OCTRL_sub0             /* OCTRL register */
        pPWM0->SUB[0].OCTRL.R   = FlexPWM0_OCTRL_sub0;
    #endif

    #ifdef FlexPWM0_INTEN_sub0             /* INTEN register */
        pPWM0->SUB[0].INTEN.R   = FlexPWM0_INTEN_sub0;
    #endif

    #ifdef FlexPWM0_DMAEN_sub0             /* DMAEN register */
        pPWM0->SUB[0].DMAEN.R   = FlexPWM0_DMAEN_sub0;
    #endif

    #ifdef FlexPWM0_TCTRL_sub0             /* TCTRL register */
        pPWM0->SUB[0].TCTRL.R   = FlexPWM0_TCTRL_sub0;
    #endif

    #ifdef FlexPWM0_DISMAP_sub0            /* DISMAP register */
        pPWM0->SUB[0].DISMAP.R  = FlexPWM0_DISMAP_sub0;
    #endif

    #ifdef FlexPWM0_DTCNT0_sub0            /* DTCNT0 register */
        pPWM0->SUB[0].DTCNT0.R  = FlexPWM0_DTCNT0_sub0;
    #endif

    #ifdef FlexPWM0_DTCNT1_sub0            /* DTCNT1 register */
        pPWM0->SUB[0].DTCNT1.R  = FlexPWM0_DTCNT1_sub0;
    #endif

    #ifdef FlexPWM0_CAPCTRLA_sub0          /* CAPCTRLA register */
        pPWM0->SUB[0].CAPCTRLA.R    = FlexPWM0_CAPCTRLA_sub0;
    #endif

    #ifdef FlexPWM0_CAPCTRLB_sub0          /* CAPCTRLB register */
        pPWM0->SUB[0].CAPCTRLB.R    = FlexPWM0_CAPCTRLB_sub0;
    #endif

    #ifdef FlexPWM0_CAPTCTRLX_sub0          /* CAPCTRLX register */
        pPWM0->SUB[0].CAPTCTRLX.R    = FlexPWM0_CAPTCTRLX_sub0;
    #endif

    #ifdef FlexPWM0_CAPTCOMPA_sub0          /* CAPTCOMPA register */
//        pPWM0->SUB[0].CAPTCOMPA.R   = FlexPWM0_CAPTCOMPA_sub0;
    #endif

    #ifdef FlexPWM0_CAPTCOMPB_sub0          /* CAPTCOMPB register */
//        pPWM0->SUB[0].CAPTCOMPB.R   = FlexPWM0_CAPTCOMPB_sub0;
    #endif

    #ifdef FlexPWM0_CAPTCOMPX_sub0          /* CAPTCOMPX register */
        pPWM0->SUB[0].CAPTCOMPX.R   = FlexPWM0_CAPTCOMPX_sub0;
    #endif

    /*-------------------------------------------------------------------------
     * FlexPWM0 sub1 registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM0_INIT_sub1              /* INIT register */
        pPWM0->SUB[1].INIT.R    = FlexPWM0_INIT_sub1;
    #endif

    #ifdef FlexPWM0_CTRL2_sub1              /* CTRL2 register */
        pPWM0->SUB[1].CTRL2.R   = FlexPWM0_CTRL2_sub1;
    #endif

    #ifdef FlexPWM0_CTRL1_sub1              /* CTRL register */
        pPWM0->SUB[1].CTRL1.R    = FlexPWM0_CTRL1_sub1;
    #endif

    #ifdef FlexPWM0_VAL0_sub1              /* VAL0 register */
        pPWM0->SUB[1].VAL[0].R  = FlexPWM0_VAL0_sub1;
    #endif

    #ifdef FlexPWM0_VAL1_sub1              /* VAL1 register */
        pPWM0->SUB[1].VAL[1].R  = FlexPWM0_VAL1_sub1;
    #endif

    #ifdef FlexPWM0_VAL2_sub1              /* VAL2 register */
        pPWM0->SUB[1].VAL[2].R  = FlexPWM0_VAL2_sub1;
    #endif

    #ifdef FlexPWM0_VAL3_sub1              /* VAL3 register */
        pPWM0->SUB[1].VAL[3].R  = FlexPWM0_VAL3_sub1;
    #endif

    #ifdef FlexPWM0_VAL4_sub1              /* VAL4 register */
        pPWM0->SUB[1].VAL[4].R  = FlexPWM0_VAL4_sub1;
    #endif

    #ifdef FlexPWM0_VAL5_sub1              /* VAL5 register */
        pPWM0->SUB[1].VAL[5].R  = FlexPWM0_VAL5_sub1;
    #endif

    #ifdef FlexPWM0_OCTRL_sub1             /* OCTRL register */
        pPWM0->SUB[1].OCTRL.R   = FlexPWM0_OCTRL_sub1;
    #endif

    #ifdef FlexPWM0_INTEN_sub1             /* INTEN register */
        pPWM0->SUB[1].INTEN.R   = FlexPWM0_INTEN_sub1;
    #endif

    #ifdef FlexPWM0_DMAEN_sub1             /* DMAEN register */
        pPWM0->SUB[1].DMAEN.R   = FlexPWM0_DMAEN_sub1;
    #endif

    #ifdef FlexPWM0_TCTRL_sub1             /* TCTRL register */
        pPWM0->SUB[1].TCTRL.R   = FlexPWM0_TCTRL_sub1;
    #endif

    #ifdef FlexPWM0_DISMAP_sub1            /* DISMAP register */
        pPWM0->SUB[1].DISMAP.R  = FlexPWM0_DISMAP_sub1;
    #endif

    #ifdef FlexPWM0_DTCNT0_sub1            /* DTCNT0 register */
        pPWM0->SUB[1].DTCNT0.R  = FlexPWM0_DTCNT0_sub1;
    #endif

    #ifdef FlexPWM0_DTCNT1_sub1            /* DTCNT1 register */
        pPWM0->SUB[1].DTCNT1.R  = FlexPWM0_DTCNT1_sub1;
    #endif

    #ifdef FlexPWM0_CAPCTRLA_sub1          /* CAPCTRLA register */
        pPWM0->SUB[1].CAPCTRLA.R    = FlexPWM0_CAPCTRLA_sub1;
    #endif

    #ifdef FlexPWM0_CAPCTRLB_sub1          /* CAPCTRLB register */
        pPWM0->SUB[1].CAPCTRLB.R    = FlexPWM0_CAPCTRLB_sub1;
    #endif

    #ifdef FlexPWM0_CAPTCTRLX_sub1          /* CAPCTRLX register */
        pPWM0->SUB[1].CAPTCTRLX.R    = FlexPWM0_CAPTCTRLX_sub1;
    #endif

    #ifdef FlexPWM0_CAPTCOMPA_sub1          /* CAPTCOMPA register */
//        pPWM0->SUB[1].CAPTCOMPA.R   = FlexPWM0_CAPTCOMPA_sub1;
    #endif

    #ifdef FlexPWM0_CAPTCOMPB_sub1          /* CAPTCOMPB register */
//        pPWM0->SUB[1].CAPTCOMPB.R   = FlexPWM0_CAPTCOMPB_sub1;
    #endif

    #ifdef FlexPWM0_CAPTCOMPX_sub1          /* CAPTCOMPX register */
        pPWM0->SUB[1].CAPTCOMPX.R   = FlexPWM0_CAPTCOMPX_sub1;
    #endif

    /*-------------------------------------------------------------------------
     * FlexPWM0 sub2 registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM0_INIT_sub2              /* INIT register */
        pPWM0->SUB[2].INIT.R    = FlexPWM0_INIT_sub2;
    #endif

    #ifdef FlexPWM0_CTRL2_sub2              /* CTRL2 register */
        pPWM0->SUB[2].CTRL2.R   = FlexPWM0_CTRL2_sub2;
    #endif

    #ifdef FlexPWM0_CTRL1_sub2              /* CTRL register */
        pPWM0->SUB[2].CTRL1.R    = FlexPWM0_CTRL1_sub2;
    #endif

    #ifdef FlexPWM0_VAL0_sub2              /* VAL0 register */
        pPWM0->SUB[2].VAL[0].R  = FlexPWM0_VAL0_sub2;
    #endif

    #ifdef FlexPWM0_VAL1_sub2              /* VAL1 register */
        pPWM0->SUB[2].VAL[1].R  = FlexPWM0_VAL1_sub2;
    #endif

    #ifdef FlexPWM0_VAL2_sub2              /* VAL2 register */
        pPWM0->SUB[2].VAL[2].R  = FlexPWM0_VAL2_sub2;
    #endif

    #ifdef FlexPWM0_VAL3_sub2              /* VAL3 register */
        pPWM0->SUB[2].VAL[3].R  = FlexPWM0_VAL3_sub2;
    #endif

    #ifdef FlexPWM0_VAL4_sub2              /* VAL4 register */
        pPWM0->SUB[2].VAL[4].R  = FlexPWM0_VAL4_sub2;
    #endif

    #ifdef FlexPWM0_VAL5_sub2              /* VAL5 register */
        pPWM0->SUB[2].VAL[5].R  = FlexPWM0_VAL5_sub2;
    #endif

    #ifdef FlexPWM0_OCTRL_sub2             /* OCTRL register */
        pPWM0->SUB[2].OCTRL.R   = FlexPWM0_OCTRL_sub2;
    #endif

    #ifdef FlexPWM0_INTEN_sub2             /* INTEN register */
        pPWM0->SUB[2].INTEN.R   = FlexPWM0_INTEN_sub2;
    #endif

    #ifdef FlexPWM0_DMAEN_sub2             /* DMAEN register */
        pPWM0->SUB[2].DMAEN.R   = FlexPWM0_DMAEN_sub2;
    #endif

    #ifdef FlexPWM0_TCTRL_sub2             /* TCTRL register */
        pPWM0->SUB[2].TCTRL.R   = FlexPWM0_TCTRL_sub2;
    #endif

    #ifdef FlexPWM0_DISMAP_sub2            /* DISMAP register */
        pPWM0->SUB[2].DISMAP.R  = FlexPWM0_DISMAP_sub2;
    #endif

    #ifdef FlexPWM0_DTCNT0_sub2            /* DTCNT0 register */
        pPWM0->SUB[2].DTCNT0.R  = FlexPWM0_DTCNT0_sub2;
    #endif

    #ifdef FlexPWM0_DTCNT1_sub2            /* DTCNT1 register */
        pPWM0->SUB[2].DTCNT1.R  = FlexPWM0_DTCNT1_sub2;
    #endif

    #ifdef FlexPWM0_CAPCTRLA_sub2          /* CAPCTRLA register */
        pPWM0->SUB[2].CAPCTRLA.R    = FlexPWM0_CAPCTRLA_sub2;
    #endif

    #ifdef FlexPWM0_CAPCTRLB_sub2          /* CAPCTRLB register */
        pPWM0->SUB[2].CAPCTRLB.R    = FlexPWM0_CAPCTRLB_sub2;
    #endif

    #ifdef FlexPWM0_CAPTCTRLX_sub2          /* CAPCTRLX register */
        pPWM0->SUB[2].CAPTCTRLX.R    = FlexPWM0_CAPTCTRLX_sub2;
    #endif

    #ifdef FlexPWM0_CAPTCOMPA_sub2          /* CAPTCOMPA register */
//        pPWM0->SUB[2].CAPTCOMPA.R   = FlexPWM0_CAPTCOMPA_sub2;
    #endif

    #ifdef FlexPWM0_CAPTCOMPB_sub2          /* CAPTCOMPB register */
//        pPWM0->SUB[2].CAPTCOMPB.R   = FlexPWM0_CAPTCOMPB_sub2;
    #endif

    #ifdef FlexPWM0_CAPTCOMPX_sub2          /* CAPTCOMPX register */
        pPWM0->SUB[2].CAPTCOMPX.R   = FlexPWM0_CAPTCOMPX_sub2;
    #endif

    /*-------------------------------------------------------------------------
     * FlexPWM0 sub3 registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM0_INIT_sub3              /* INIT register */
        pPWM0->SUB[3].INIT.R    = FlexPWM0_INIT_sub3;
    #endif

    #ifdef FlexPWM0_CTRL2_sub3              /* CTRL2 register */
        pPWM0->SUB[3].CTRL2.R   = FlexPWM0_CTRL2_sub3;
    #endif

    #ifdef FlexPWM0_CTRL1_sub3              /* CTRL register */
        pPWM0->SUB[3].CTRL1.R    = FlexPWM0_CTRL1_sub3;
    #endif

    #ifdef FlexPWM0_VAL0_sub3              /* VAL0 register */
        pPWM0->SUB[3].VAL[0].R  = FlexPWM0_VAL0_sub3;
    #endif

    #ifdef FlexPWM0_VAL1_sub3              /* VAL1 register */
        pPWM0->SUB[3].VAL[1].R  = FlexPWM0_VAL1_sub3;
    #endif

    #ifdef FlexPWM0_VAL2_sub3              /* VAL2 register */
        pPWM0->SUB[3].VAL[2].R  = FlexPWM0_VAL2_sub3;
    #endif

    #ifdef FlexPWM0_VAL3_sub3              /* VAL3 register */
        pPWM0->SUB[3].VAL[3].R  = FlexPWM0_VAL3_sub3;
    #endif

    #ifdef FlexPWM0_VAL4_sub3              /* VAL4 register */
        pPWM0->SUB[3].VAL[4].R  = FlexPWM0_VAL4_sub3;
    #endif

    #ifdef FlexPWM0_VAL5_sub3              /* VAL5 register */
        pPWM0->SUB[3].VAL[5].R  = FlexPWM0_VAL5_sub3;
    #endif

    #ifdef FlexPWM0_OCTRL_sub3             /* OCTRL register */
        pPWM0->SUB[3].OCTRL.R   = FlexPWM0_OCTRL_sub3;
    #endif

    #ifdef FlexPWM0_INTEN_sub3             /* INTEN register */
        pPWM0->SUB[3].INTEN.R   = FlexPWM0_INTEN_sub3;
    #endif

    #ifdef FlexPWM0_DMAEN_sub3             /* DMAEN register */
        pPWM0->SUB[3].DMAEN.R   = FlexPWM0_DMAEN_sub3;
    #endif

    #ifdef FlexPWM0_TCTRL_sub3             /* TCTRL register */
        pPWM0->SUB[3].TCTRL.R   = FlexPWM0_TCTRL_sub3;
    #endif

    #ifdef FlexPWM0_DISMAP_sub3            /* DISMAP register */
        pPWM0->SUB[3].DISMAP.R  = FlexPWM0_DISMAP_sub3;
    #endif

    #ifdef FlexPWM0_DTCNT0_sub3            /* DTCNT0 register */
        pPWM0->SUB[3].DTCNT0.R  = FlexPWM0_DTCNT0_sub3;
    #endif

    #ifdef FlexPWM0_DTCNT1_sub3            /* DTCNT1 register */
        pPWM0->SUB[3].DTCNT1.R  = FlexPWM0_DTCNT1_sub3;
    #endif

    #ifdef FlexPWM0_CAPCTRLA_sub3          /* CAPCTRLA register */
        pPWM0->SUB[3].CAPCTRLA.R    = FlexPWM0_CAPCTRLA_sub3;
    #endif

    #ifdef FlexPWM0_CAPCTRLB_sub3          /* CAPCTRLB register */
        pPWM0->SUB[3].CAPCTRLB.R    = FlexPWM0_CAPCTRLB_sub3;
    #endif

    #ifdef FlexPWM0_CAPTCTRLX_sub3          /* CAPCTRLX register */
        pPWM0->SUB[3].CAPTCTRLX.R    = FlexPWM0_CAPTCTRLX_sub3;
    #endif

    #ifdef FlexPWM0_CAPTCOMPA_sub3          /* CAPTCOMPA register */
//        pPWM0->SUB[3].CAPTCOMPA.R   = FlexPWM0_CAPTCOMPA_sub3;
    #endif

    #ifdef FlexPWM0_CAPTCOMPB_sub3          /* CAPTCOMPB register */
//        pPWM0->SUB[3].CAPTCOMPB.R   = FlexPWM0_CAPTCOMPB_sub3;
    #endif

    #ifdef FlexPWM0_CAPTCOMPX_sub3          /* CAPTCOMPX register */
        pPWM0->SUB[3].CAPTCOMPX.R   = FlexPWM0_CAPTCOMPX_sub3;
    #endif

    #ifdef FlexPWM0_MCTRL                  /* MCTRL register */
        pPWM0->MCTRL.R      |= FlexPWM0_MCTRL;
    #endif

    ldok_test = pPWM0->MCTRL.B.LDOK;    // Read the LDOK bit field first
    pPWM0->MCTRL.R          |= LDOK_SUB0|LDOK_SUB1|LDOK_SUB2|LDOK_SUB3;

}

/***************************************************************************//*!
@brief          flexPWM0 init function

@param[in,out]  void
@param[in]      void

@return         void

@details        This function initializes basic start-up setting of the PWM1
                module.

@note

@warning
******************************************************************************/
void flexpwm1_init(void)
{
    static volatile tU8  i,j;
    volatile tU8     ldok_test;

    pPWM1=(mcPWM_tag *)&mcPWM_B;

    /* Double Buffered Registers    DB1
     * The value written does not take effect until the LDOK bit is set and
     * the next PWM load cycle begins or LDMOD is set. This register cannot
     * be written when LDOK is set.
     */

    /*-------------------------------------------------------------------------
     * FlexPWM0 Reset
    --------------------------------------------------------------------------*/
    pPWM1->MCTRL.R          = 0x0;
    pPWM1->OUTEN.R          = 0x0;
    pPWM1->MASK.R           = 0x0;
    pPWM1->SWCOUT.R         = 0x0;
    pPWM1->DTSRCSEL.R       = 0x0;
    pPWM1->FCTRL.R          = 0x0;
    pPWM1->FFILT.R          = 0x0;
    pPWM1->FSTS.R           = 0xF;  // Clear Fault PIN flags manually

    for (j=0;j<=3;j++)
    {
        pPWM1->SUB[j].INIT.R        = 0x0;
        pPWM1->SUB[j].CTRL2.R       = 0x0;
        pPWM1->SUB[j].CTRL1.R        = 0x0;

        for(i=0;i<=5;i++)
        pPWM1->SUB[j].VAL[i].R      = 0x0;

        pPWM1->SUB[j].OCTRL.R       = 0x0;
        pPWM1->SUB[j].INTEN.R       = 0x0;
        pPWM1->SUB[j].DMAEN.R       = 0x0;
        pPWM1->SUB[j].TCTRL.R       = 0x0;
        pPWM1->SUB[j].DISMAP.R      = 0x0;
        pPWM1->SUB[j].DTCNT0.R      = 0x07FF;
        pPWM1->SUB[j].DTCNT1.R      = 0x07FF;
//        pPWM1->SUB[j].CAPTCOMPA.R   = 0x0;
//        pPWM1->SUB[j].CAPTCOMPB.R   = 0x0;
        pPWM1->SUB[j].CAPTCOMPX.R   = 0x0;
//        pPWM1->SUB[j].CAPTCTRLA.R   = 0x0;
//        pPWM1->SUB[j].CAPTCTRLB.R   = 0x0;
        pPWM1->SUB[j].CAPTCTRLX.R   = 0x0;
        pPWM1->SUB[j].DISMAP.R      = 0xFFFF;
    }

    /*-------------------------------------------------------------------------
     * FlexPWM1 Control registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM1_OUTEN                  /* OUTEN register */
        pPWM1->OUTEN.R          = FlexPWM1_OUTEN;
    #endif

    #ifdef FlexPWM1_MASK                   /* MASK register */
        pPWM1->MASK.R           = FlexPWM1_MASK;
    #endif

    #ifdef FlexPWM1_SWCOUT                 /* SWCOUT register */
        pPWM1->SWCOUT.R         = FlexPWM1_SWCOUT;
    #endif

    #ifdef FlexPWM1_DTSRCSEL               /* DTSRCSEL register */
        pPWM1->DTSRCSEL.R       = FlexPWM1_DTSRCSEL;
    #endif

    #ifdef FlexPWM1_FCTRL                  /* FCTRL register */
        pPWM1->FCTRL.R          = FlexPWM1_FCTRL;
    #endif

    #ifdef FlexPWM1_FFILT                  /* FFILT register */
        pPWM1->FFILT.R          = FlexPWM1_FFILT;
    #endif

    /*-------------------------------------------------------------------------
     * FlexPWM1 sub0 registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM1_INIT_sub0              /* INIT register */
        pPWM1->SUB[0].INIT.R    = FlexPWM1_INIT_sub0;
    #endif

    #ifdef FlexPWM1_CTRL2_sub0              /* CTRL2 register */
        pPWM1->SUB[0].CTRL2.R   = FlexPWM1_CTRL2_sub0;
    #endif

    #ifdef FlexPWM1_CTRL1_sub0              /* CTRL register */
        pPWM1->SUB[0].CTRL1.R    = FlexPWM1_CTRL1_sub0;
    #endif

    #ifdef FlexPWM1_VAL0_sub0              /* VAL0 register */
        pPWM1->SUB[0].VAL[0].R  = FlexPWM1_VAL0_sub0;
    #endif

    #ifdef FlexPWM1_VAL1_sub0              /* VAL1 register */
        pPWM1->SUB[0].VAL[1].R  = FlexPWM1_VAL1_sub0;
    #endif

    #ifdef FlexPWM1_VAL2_sub0              /* VAL2 register */
        pPWM1->SUB[0].VAL[2].R  = FlexPWM1_VAL2_sub0;
    #endif

    #ifdef FlexPWM1_VAL3_sub0              /* VAL3 register */
        pPWM1->SUB[0].VAL[3].R  = FlexPWM1_VAL3_sub0;
    #endif

    #ifdef FlexPWM1_VAL4_sub0              /* VAL4 register */
        pPWM1->SUB[0].VAL[4].R  = FlexPWM1_VAL4_sub0;
    #endif

    #ifdef FlexPWM1_VAL5_sub0              /* VAL5 register */
        pPWM1->SUB[0].VAL[5].R  = FlexPWM1_VAL5_sub0;
    #endif

    #ifdef FlexPWM1_OCTRL_sub0             /* OCTRL register */
        pPWM1->SUB[0].OCTRL.R   = FlexPWM1_OCTRL_sub0;
    #endif

    #ifdef FlexPWM1_INTEN_sub0             /* INTEN register */
        pPWM1->SUB[0].INTEN.R   = FlexPWM1_INTEN_sub0;
    #endif

    #ifdef FlexPWM1_DMAEN_sub0             /* DMAEN register */
        pPWM1->SUB[0].DMAEN.R   = FlexPWM1_DMAEN_sub0;
    #endif

    #ifdef FlexPWM1_TCTRL_sub0             /* TCTRL register */
        pPWM1->SUB[0].TCTRL.R   = FlexPWM1_TCTRL_sub0;
    #endif

    #ifdef FlexPWM1_DISMAP_sub0            /* DISMAP register */
        pPWM1->SUB[0].DISMAP.R  = FlexPWM1_DISMAP_sub0;
    #endif

    #ifdef FlexPWM1_DTCNT0_sub0            /* DTCNT0 register */
        pPWM1->SUB[0].DTCNT0.R  = FlexPWM1_DTCNT0_sub0;
    #endif

    #ifdef FlexPWM1_DTCNT1_sub0            /* DTCNT1 register */
        pPWM1->SUB[0].DTCNT1.R  = FlexPWM1_DTCNT1_sub0;
    #endif

    #ifdef FlexPWM1_CAPCTRLA_sub0          /* CAPCTRLA register */
        pPWM1->SUB[0].CAPCTRLA.R    = FlexPWM1_CAPCTRLA_sub0;
    #endif

    #ifdef FlexPWM1_CAPCTRLB_sub0          /* CAPCTRLB register */
        pPWM1->SUB[0].CAPCTRLB.R    = FlexPWM1_CAPCTRLB_sub0;
    #endif

    #ifdef FlexPWM1_CAPTCTRLX_sub0          /* CAPCTRLX register */
        pPWM1->SUB[0].CAPTCTRLX.R    = FlexPWM1_CAPTCTRLX_sub0;
    #endif

    #ifdef FlexPWM1_CAPTCOMPA_sub0          /* CAPTCOMPA register */
//        pPWM1->SUB[0].CAPTCOMPA.R   = FlexPWM1_CAPTCOMPA_sub0;
    #endif

    #ifdef FlexPWM1_CAPTCOMPB_sub0          /* CAPTCOMPB register */
//        pPWM1->SUB[0].CAPTCOMPB.R   = FlexPWM1_CAPTCOMPB_sub0;
    #endif

    #ifdef FlexPWM1_CAPTCOMPX_sub0          /* CAPTCOMPX register */
        pPWM1->SUB[0].CAPTCOMPX.R   = FlexPWM1_CAPTCOMPX_sub0;
    #endif

    /*-------------------------------------------------------------------------
     * FlexPWM1 sub1 registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM1_INIT_sub1              /* INIT register */
        pPWM1->SUB[1].INIT.R    = FlexPWM1_INIT_sub1;
    #endif

    #ifdef FlexPWM1_CTRL2_sub1              /* CTRL2 register */
        pPWM1->SUB[1].CTRL2.R   = FlexPWM1_CTRL2_sub1;
    #endif

    #ifdef FlexPWM1_CTRL1_sub1              /* CTRL register */
        pPWM1->SUB[1].CTRL1.R    = FlexPWM1_CTRL1_sub1;
    #endif

    #ifdef FlexPWM1_VAL0_sub1              /* VAL0 register */
        pPWM1->SUB[1].VAL[0].R  = FlexPWM1_VAL0_sub1;
    #endif

    #ifdef FlexPWM1_VAL1_sub1              /* VAL1 register */
        pPWM1->SUB[1].VAL[1].R  = FlexPWM1_VAL1_sub1;
    #endif

    #ifdef FlexPWM1_VAL2_sub1              /* VAL2 register */
        pPWM1->SUB[1].VAL[2].R  = FlexPWM1_VAL2_sub1;
    #endif

    #ifdef FlexPWM1_VAL3_sub1              /* VAL3 register */
        pPWM1->SUB[1].VAL[3].R  = FlexPWM1_VAL3_sub1;
    #endif

    #ifdef FlexPWM1_VAL4_sub1              /* VAL4 register */
        pPWM1->SUB[1].VAL[4].R  = FlexPWM1_VAL4_sub1;
    #endif

    #ifdef FlexPWM1_VAL5_sub1              /* VAL5 register */
        pPWM1->SUB[1].VAL[5].R  = FlexPWM1_VAL5_sub1;
    #endif

    #ifdef FlexPWM1_OCTRL_sub1             /* OCTRL register */
        pPWM1->SUB[1].OCTRL.R   = FlexPWM1_OCTRL_sub1;
    #endif

    #ifdef FlexPWM1_INTEN_sub1             /* INTEN register */
        pPWM1->SUB[1].INTEN.R   = FlexPWM1_INTEN_sub1;
    #endif

    #ifdef FlexPWM1_DMAEN_sub1             /* DMAEN register */
        pPWM1->SUB[1].DMAEN.R   = FlexPWM1_DMAEN_sub1;
    #endif

    #ifdef FlexPWM1_TCTRL_sub1             /* TCTRL register */
        pPWM1->SUB[1].TCTRL.R   = FlexPWM1_TCTRL_sub1;
    #endif

    #ifdef FlexPWM1_DISMAP_sub1            /* DISMAP register */
        pPWM1->SUB[1].DISMAP.R  = FlexPWM1_DISMAP_sub1;
    #endif

    #ifdef FlexPWM1_DTCNT0_sub1            /* DTCNT0 register */
        pPWM1->SUB[1].DTCNT0.R  = FlexPWM1_DTCNT0_sub1;
    #endif

    #ifdef FlexPWM1_DTCNT1_sub1            /* DTCNT1 register */
        pPWM1->SUB[1].DTCNT1.R  = FlexPWM1_DTCNT1_sub1;
    #endif

    #ifdef FlexPWM1_CAPCTRLA_sub1          /* CAPCTRLA register */
        pPWM1->SUB[1].CAPCTRLA.R    = FlexPWM1_CAPCTRLA_sub1;
    #endif

    #ifdef FlexPWM1_CAPCTRLB_sub1          /* CAPCTRLB register */
        pPWM1->SUB[1].CAPCTRLB.R    = FlexPWM1_CAPCTRLB_sub1;
    #endif

    #ifdef FlexPWM1_CAPTCTRLX_sub1          /* CAPCTRLX register */
        pPWM1->SUB[1].CAPTCTRLX.R    = FlexPWM1_CAPTCTRLX_sub1;
    #endif

    #ifdef FlexPWM1_CAPTCOMPA_sub1          /* CAPTCOMPA register */
//        pPWM1->SUB[1].CAPTCOMPA.R   = FlexPWM1_CAPTCOMPA_sub1;
    #endif

    #ifdef FlexPWM1_CAPTCOMPB_sub1          /* CAPTCOMPB register */
//        pPWM1->SUB[1].CAPTCOMPB.R   = FlexPWM1_CAPTCOMPB_sub1;
    #endif

    #ifdef FlexPWM1_CAPTCOMPX_sub1          /* CAPTCOMPX register */
        pPWM1->SUB[1].CAPTCOMPX.R   = FlexPWM1_CAPTCOMPX_sub1;
    #endif

    /*-------------------------------------------------------------------------
     * FlexPWM1 sub2 registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM1_INIT_sub2              /* INIT register */
        pPWM1->SUB[2].INIT.R    = FlexPWM1_INIT_sub2;
    #endif

    #ifdef FlexPWM1_CTRL2_sub2              /* CTRL2 register */
        pPWM1->SUB[2].CTRL2.R   = FlexPWM1_CTRL2_sub2;
    #endif

    #ifdef FlexPWM1_CTRL1_sub2              /* CTRL register */
        pPWM1->SUB[2].CTRL1.R    = FlexPWM1_CTRL1_sub2;
    #endif

    #ifdef FlexPWM1_VAL0_sub2              /* VAL0 register */
        pPWM1->SUB[2].VAL[0].R  = FlexPWM1_VAL0_sub2;
    #endif

    #ifdef FlexPWM1_VAL1_sub2              /* VAL1 register */
        pPWM1->SUB[2].VAL[1].R  = FlexPWM1_VAL1_sub2;
    #endif

    #ifdef FlexPWM1_VAL2_sub2              /* VAL2 register */
        pPWM1->SUB[2].VAL[2].R  = FlexPWM1_VAL2_sub2;
    #endif

    #ifdef FlexPWM1_VAL3_sub2              /* VAL3 register */
        pPWM1->SUB[2].VAL[3].R  = FlexPWM1_VAL3_sub2;
    #endif

    #ifdef FlexPWM1_VAL4_sub2              /* VAL4 register */
        pPWM1->SUB[2].VAL[4].R  = FlexPWM1_VAL4_sub2;
    #endif

    #ifdef FlexPWM1_VAL5_sub2              /* VAL5 register */
        pPWM1->SUB[2].VAL[5].R  = FlexPWM1_VAL5_sub2;
    #endif

    #ifdef FlexPWM1_OCTRL_sub2             /* OCTRL register */
        pPWM1->SUB[2].OCTRL.R   = FlexPWM1_OCTRL_sub2;
    #endif

    #ifdef FlexPWM1_INTEN_sub2             /* INTEN register */
        pPWM1->SUB[2].INTEN.R   = FlexPWM1_INTEN_sub2;
    #endif

    #ifdef FlexPWM1_DMAEN_sub2             /* DMAEN register */
        pPWM1->SUB[2].DMAEN.R   = FlexPWM1_DMAEN_sub2;
    #endif

    #ifdef FlexPWM1_TCTRL_sub2             /* TCTRL register */
        pPWM1->SUB[2].TCTRL.R   = FlexPWM1_TCTRL_sub2;
    #endif

    #ifdef FlexPWM1_DISMAP_sub2            /* DISMAP register */
        pPWM1->SUB[2].DISMAP.R  = FlexPWM1_DISMAP_sub2;
    #endif

    #ifdef FlexPWM1_DTCNT0_sub2            /* DTCNT0 register */
        pPWM1->SUB[2].DTCNT0.R  = FlexPWM1_DTCNT0_sub2;
    #endif

    #ifdef FlexPWM1_DTCNT1_sub2            /* DTCNT1 register */
        pPWM1->SUB[2].DTCNT1.R  = FlexPWM1_DTCNT1_sub2;
    #endif

    #ifdef FlexPWM1_CAPCTRLA_sub2          /* CAPCTRLA register */
        pPWM1->SUB[2].CAPCTRLA.R    = FlexPWM1_CAPCTRLA_sub2;
    #endif

    #ifdef FlexPWM1_CAPCTRLB_sub2          /* CAPCTRLB register */
        pPWM1->SUB[2].CAPCTRLB.R    = FlexPWM1_CAPCTRLB_sub2;
    #endif

    #ifdef FlexPWM1_CAPTCTRLX_sub2          /* CAPCTRLX register */
        pPWM1->SUB[2].CAPTCTRLX.R    = FlexPWM1_CAPTCTRLX_sub2;
    #endif

    #ifdef FlexPWM1_CAPTCOMPA_sub2          /* CAPTCOMPA register */
//        pPWM1->SUB[2].CAPTCOMPA.R   = FlexPWM1_CAPTCOMPA_sub2;
    #endif

    #ifdef FlexPWM1_CAPTCOMPB_sub2          /* CAPTCOMPB register */
//        pPWM1->SUB[2].CAPTCOMPB.R   = FlexPWM1_CAPTCOMPB_sub2;
    #endif

    #ifdef FlexPWM1_CAPTCOMPX_sub2          /* CAPTCOMPX register */
        pPWM1->SUB[2].CAPTCOMPX.R   = FlexPWM1_CAPTCOMPX_sub2;
    #endif

    /*-------------------------------------------------------------------------
     * FlexPWM1 sub3 registers
    --------------------------------------------------------------------------*/
    #ifdef FlexPWM1_INIT_sub3              /* INIT register */
        pPWM1->SUB[3].INIT.R    = FlexPWM1_INIT_sub3;
    #endif

    #ifdef FlexPWM1_CTRL2_sub3              /* CTRL2 register */
        pPWM1->SUB[3].CTRL2.R   = FlexPWM1_CTRL2_sub3;
    #endif

    #ifdef FlexPWM1_CTRL1_sub3              /* CTRL register */
        pPWM1->SUB[3].CTRL1.R    = FlexPWM1_CTRL1_sub3;
    #endif

    #ifdef FlexPWM1_VAL0_sub3              /* VAL0 register */
        pPWM1->SUB[3].VAL[0].R  = FlexPWM1_VAL0_sub3;
    #endif

    #ifdef FlexPWM1_VAL1_sub3              /* VAL1 register */
        pPWM1->SUB[3].VAL[1].R  = FlexPWM1_VAL1_sub3;
    #endif

    #ifdef FlexPWM1_VAL2_sub3              /* VAL2 register */
        pPWM1->SUB[3].VAL[2].R  = FlexPWM1_VAL2_sub3;
    #endif

    #ifdef FlexPWM1_VAL3_sub3              /* VAL3 register */
        pPWM1->SUB[3].VAL[3].R  = FlexPWM1_VAL3_sub3;
    #endif

    #ifdef FlexPWM1_VAL4_sub3              /* VAL4 register */
        pPWM1->SUB[3].VAL[4].R  = FlexPWM1_VAL4_sub3;
    #endif

    #ifdef FlexPWM1_VAL5_sub3              /* VAL5 register */
        pPWM1->SUB[3].VAL[5].R  = FlexPWM1_VAL5_sub3;
    #endif

    #ifdef FlexPWM1_OCTRL_sub3             /* OCTRL register */
        pPWM1->SUB[3].OCTRL.R   = FlexPWM1_OCTRL_sub3;
    #endif

    #ifdef FlexPWM1_INTEN_sub3             /* INTEN register */
        pPWM1->SUB[3].INTEN.R   = FlexPWM1_INTEN_sub3;
    #endif

    #ifdef FlexPWM1_DMAEN_sub3             /* DMAEN register */
        pPWM1->SUB[3].DMAEN.R   = FlexPWM1_DMAEN_sub3;
    #endif

    #ifdef FlexPWM1_TCTRL_sub3             /* TCTRL register */
        pPWM1->SUB[3].TCTRL.R   = FlexPWM1_TCTRL_sub3;
    #endif

    #ifdef FlexPWM1_DISMAP_sub3            /* DISMAP register */
        pPWM1->SUB[3].DISMAP.R  = FlexPWM1_DISMAP_sub3;
    #endif

    #ifdef FlexPWM1_DTCNT0_sub3            /* DTCNT0 register */
        pPWM1->SUB[3].DTCNT0.R  = FlexPWM1_DTCNT0_sub3;
    #endif

    #ifdef FlexPWM1_DTCNT1_sub3            /* DTCNT1 register */
        pPWM1->SUB[3].DTCNT1.R  = FlexPWM1_DTCNT1_sub3;
    #endif

    #ifdef FlexPWM1_CAPCTRLA_sub3          /* CAPCTRLA register */
        pPWM1->SUB[3].CAPCTRLA.R    = FlexPWM1_CAPCTRLA_sub3;
    #endif

    #ifdef FlexPWM1_CAPCTRLB_sub3          /* CAPCTRLB register */
        pPWM1->SUB[3].CAPCTRLB.R    = FlexPWM1_CAPCTRLB_sub3;
    #endif

    #ifdef FlexPWM1_CAPTCTRLX_sub3          /* CAPCTRLX register */
        pPWM1->SUB[3].CAPTCTRLX.R    = FlexPWM1_CAPTCTRLX_sub3;
    #endif

    #ifdef FlexPWM1_CAPTCOMPA_sub3          /* CAPTCOMPA register */
//        pPWM1->SUB[3].CAPTCOMPA.R   = FlexPWM1_CAPTCOMPA_sub3;
    #endif

    #ifdef FlexPWM1_CAPTCOMPB_sub3          /* CAPTCOMPB register */
//        pPWM1->SUB[3].CAPTCOMPB.R   = FlexPWM1_CAPTCOMPB_sub3;
    #endif

    #ifdef FlexPWM1_CAPTCOMPX_sub3          /* CAPTCOMPX register */
        pPWM1->SUB[3].CAPTCOMPX.R   = FlexPWM1_CAPTCOMPX_sub3;
    #endif

    #ifdef FlexPWM1_MCTRL                  /* MCTRL register */
        pPWM1->MCTRL.R      |= FlexPWM1_MCTRL;
    #endif

    ldok_test = pPWM1->MCTRL.B.LDOK;    // Read the LDOK bit field first
    pPWM1->MCTRL.R          |= LDOK_SUB0|LDOK_SUB1|LDOK_SUB2|LDOK_SUB3;

}
