/******************************************************************************
*
* Copyright 2006-2015 Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
*
***************************************************************************//*!
*
* @file   uart_init.c
*
* @brief  FreeMASTER driver private declarations, used internally by the driver
*
* @version 1.0.1.0
* 
* @date Nov-15-2010
* 
*******************************************************************************/
#include "uart_init.h"

volatile LINFLEX_tag *linflex0;

void uart_init(void)
{
    linflex0 =(LINFLEX_tag *)&LINFLEX0;
    //linflex0 = &LINFLEX_0;
	/*	
    // configure ports
    SIU.PCR[18].R = 0
        | PA(1)
        | OBE;                  // TXD B[2]
    SIU.PCR[19].R = 0
        | PA(0)
        | IBE;                  // RXD B[3] 
    
*/
   
    // configure linflex1
    linflex0->LINCR1.B.SLEEP = 0x0;     // disable sleep mode
    linflex0->LINCR1.B.INIT  = 0x1;     // init mode
    linflex0->UARTCR.B.UART  = 0x1;     // UART mode
    
    linflex0->UARTCR.B.TDFL_TFC = 0x0;  // bufer size = 1
    linflex0->UARTCR.B.RDFL_RFC0 = 0x0; // bufer size = 1
    linflex0->UARTCR.B.RXEN = 0x1;      // reciever enable
    linflex0->UARTCR.B.TXEN = 0x1;      // transmiter enable
    linflex0->UARTCR.B.PC0   = 0x1;     // parity is even
    linflex0->UARTCR.B.PCE  = 0x0;      // parity control disable
    linflex0->UARTCR.B.WL0   = 0x1;     // word length 8-bit data + parity bit
    //linflex0->LINIBRR.B.DIV_M = 416;    // Baud rate = 9600, in case fipg_clock_lin = 64 MHz
    //linflex0->LINFBRR.B.DIV_F = 11;     // Baud rate = 9600, in case fipg_clock_lin = 64 MHz
//    linflex0->LINIBRR.B.DIV_M = 208;    // Baud rate = 19200, in case fipg_clock_lin = 64 MHz
//    linflex0->LINFBRR.B.DIV_F = 5;      // Baud rate = 19200, in case fipg_clock_lin = 64 MHz
//    linflex0->LINIBRR.B.DIV_M = 104;    // Baud rate = 38400, in case fipg_clock_lin = 64 MHz
//    linflex0->LINFBRR.B.DIV_F = 3;      // Baud rate = 38400, in case fipg_clock_lin = 64 MHz
//    linflex0->LINIBRR.B.IBR = 51;     // Baud rate = 19200, in case fipg_clock_lin = 16 MHz
//    linflex0->LINFBRR.B.FBR = 1;      // Baud rate = 19200, in case fipg_clock_lin = 16 MHz
//    linflex0->LINIBRR.B.IBR = 260;    // Baud rate = 19200, in case fipg_clock_lin = 80 MHz
// 	  linflex0->LINFBRR.B.FBR = 1;      // Baud rate = 19200, in case fipg_clock_lin = 80 MHz

//    linflex0->LINIBRR.B.IBR = 86;    // Baud rate = 57600, in case fipg_clock_lin = 80 MHz
//    linflex0->LINFBRR.B.FBR = 13;      // Baud rate = 57600, in case fipg_clock_lin = 80 MHz

    //linflex0->LINIBRR.B.IBR = 133;    // Baud rate = 56000, in case fipg_clock_lin = 120 MHz
    //linflex0->LINFBRR.B.FBR = 15;      // Baud rate = 56000, in case fipg_clock_lin = 120 MHz

    linflex0->LINIBRR.B.IBR = 390;     // Baud rate = 19200, in case fipg_clock_lin = 120 MHz
    linflex0->LINFBRR.B.FBR = 10;      // Baud rate = 19200, in case fipg_clock_lin = 120 MHz

    //linflex0->LINIBRR.B.DIV_M = 34;       // Baud rate = 115200, in case fipg_clock_lin = 64 MHz

    // configure interupts - enable
//    linflex0->LINIER.B.DRIE  = 0x1;       // data reception complete interrupt
//    linflex0->LINIER.B.DTIE  = 0x1;       // data transmition complete interrupt  
//    linflex0->LINIER.B.DBFIE = 0x1;       // 
//    linflex0->LINIER.B.DBEIE = 0x1;       // 

    // or disable
    linflex0->LINIER.B.DRIE  = 0x0;     // data reception complete interrupt
    linflex0->LINIER.B.DTIE  = 0x0;     // data transmition complete interrupt  
    linflex0->LINIER.B.DBFIE = 0x0;     // 
    linflex0->LINIER.B.DBEIE_TOIE = 0x0;     //
    
    linflex0->LINCR1.B.INIT = 0x0;      // normal mode

    // set priority
    //INTC.PSR[79].B.PRI = 2;
    //INTC.PSR[80].B.PRI = 2; 
    //INTC.PSR[81].B.PRI = 2; 	
}

// for testing purpose
void uart_rx_isr()
{ 
	FMSTR_SCI_RDCLRSR(); 
	FMSTR_SCI_PUTCHAR(FMSTR_SCI_GETCHAR()); // output - input
}

void uart_tx_isr()
{ 
	FMSTR_SCI_RDCLRSR();  
	linflex0->UARTSR.B.DTF_TFF = 0x1;
}	    

// *****************************************************************************
