/******************************************************************************
*
* Copyright 2006-2015 Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
*
***************************************************************************//*!
*
* @file      state_machine.h
*
* @author    b34195
* 
* @version   1.0.1.0
* 
* @date      Jul-13-2012
* 
* @brief     Header file for StateMachineFrame "c" project
*
*******************************************************************************
*
* Detailed Description of the file. If not used, remove the separator above.
*
******************************************************************************/

#ifndef _STATE_MACHINE_FRAME_H
#define _STATE_MACHINE_FRAME_H

/******************************************************************************
* Includes
******************************************************************************/
#include "motor_structure.h"

/******************************************************************************
* Constants
******************************************************************************/
#define	TURNED_ON	0x1
#define	TURNED_OFF	0x0

#ifndef true
#define true  ((tBool)1)
#endif

#ifndef false
#define false ((tBool)0)
#endif

typedef void (*PFCN_VOID_PARAM_PMSM)(pmsmDrive_t *ptr); /* pointer to function with parameter*/
typedef void (*PFCN_VOID_LED)(pmsmDrive_t *ptr, tS32 SUIL_PAD); /* pointer to function with parameters*/

extern PFCN_VOID_PARAM_PMSM state_table[12][6];
extern PFCN_VOID_LED state_LED[6];

/* LED application control*/
extern void stateLedOFF(pmsmDrive_t *ptr, tS32 SUIL_PAD_ADDR);
extern void stateLedON(pmsmDrive_t *ptr, tS32 SUIL_PAD_ADDR);
extern void stateLedFLASHING_SLOW(pmsmDrive_t *ptr, tS32 SUIL_PAD_ADDR);
extern void stateLedFLASHING_FAST(pmsmDrive_t *ptr, tS32 SUIL_PAD_ADDR);

#endif //_STATE_MACHINE_FRAME_H
